package jp.co.asterisk.asreader.l251g.support.rfm;

public class RFMHelper {
    public static final String TAG = RFMHelper.class.getSimpleName();

    public static final RFMHelper instance = new RFMHelper();

    private RFMHelper() {
    }

    public static RFMHelper getInstance() {
        return instance;
    }


    public String calculationTemp(String tempCode, String cal){

        if((tempCode == null)||(cal == null))
            return null;

        cal = cal.toLowerCase();

//        Log.d(TAG+"[CEJ]", "== RFM Check1 : " + sensCode + " cal : " + cal);

        String calibBinaryData = convertHexToBinary(cal);

//        Log.d(TAG+"[CEJ]", "== RFM Check2 : " + calibBinaryData);

        String calibBinaryCode1 = calibBinaryData.substring(0,12);  // 문서 Table 9. 참고
        String calibBinaryTemp1 = calibBinaryData.substring(12,23);
        String calibBinaryCode2 = calibBinaryData.substring(23,35);
        String calibBinaryTemp2 = calibBinaryData.substring(35, calibBinaryData.length()-2);

//        Log.d(TAG+"[CEJ]", "== RFM Check3 : " + calibBinaryCode1
//                +" " + calibBinaryTemp1 + " " + calibBinaryCode2 + " "+calibBinaryTemp2);

        //binary string to int
        int calibCode1 = convertBinaryStringToDecimalNumber(calibBinaryCode1);
        int calibCode2 = convertBinaryStringToDecimalNumber(calibBinaryCode2);
        int calibTemp1 = convertBinaryStringToDecimalNumber(calibBinaryTemp1);
        int calibTemp2 = convertBinaryStringToDecimalNumber(calibBinaryTemp2);

//        Log.d(TAG+"[CEJ]", "== RFM Check4 : " + calibCode1
//                +" " + calibCode2 + " " + calibTemp1 + " "+calibTemp2);

        int code =  convertHexStringToInt(tempCode);
        float temperatureVal = (float) (0.1*( (calibTemp2-calibTemp1)/(calibCode2-calibCode1)*(code-calibCode1)+calibTemp1-800));

//        Log.d(TAG+"[CEJ]", "== RFM Check5 : " + " code : " + code + " temperatureVal : " + temperatureVal);

        return String.valueOf(temperatureVal);
    }

    public String calculationSensorCode(String sensCode, String tid){
        if((sensCode == null)||(tid == null))
            return null;

        sensCode =  sensCode.substring(0,4);
        int code =  Integer.parseInt(sensCode,16);

        return String.valueOf(code);
    }

    private String convertHexToBinary(String hexString){
        // string 한글자씩 배열에넣기
        String[] strArray = hexString.split("");

        String returnString = "";
        for(String s : strArray) {
            switch(s) {
                case "0": returnString += "0000"; break;
                case "1": returnString += "0001"; break;
                case "2": returnString += "0010"; break;
                case "3": returnString += "0011"; break;
                case "4": returnString += "0100"; break;
                case "5": returnString += "0101"; break;
                case "6": returnString += "0110"; break;
                case "7": returnString += "0111"; break;
                case "8": returnString += "1000"; break;
                case "9": returnString += "1001"; break;
                case "a": returnString += "1010"; break;
                case "b": returnString += "1011"; break;
                case "c": returnString += "1100"; break;
                case "d": returnString += "1101"; break;
                case "e": returnString += "1110"; break;
                case "f": returnString += "1111"; break;
                default : break;
            }
        }
        return returnString;
    }

    private int convertBinaryStringToDecimalNumber(String binaryString){
        char[] numbers = binaryString.toCharArray();
        int result = 0;
        for(int i=numbers.length - 1; i>=0; i--)
            if(numbers[i]=='1')
                result += Math.pow(2, (numbers.length-i - 1));
        return result;
    }

    private int convertHexStringToInt(String hexString){
        return Integer.parseInt(hexString, 16);
    }

}
