package jp.co.asterisk.asreader.l251g.support.view.base;

import jp.co.asterisk.asreader.l251g.support.util.ResUtil;
import com.asreader.lib.diagnostics.ASRLog;
import jp.co.asterisk.asreader.l251g.R;

import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

public abstract class RfidClearActivity extends RfidActivity implements
		OnClickListener {

	private static final String TAG = RfidClearActivity.class.getSimpleName();
	
	protected Button btnClear;
	protected Button btnOption;

	@Override
	public void onClick(View v) {
		
		ASRLog.i(TAG, ASRLog.INFO, "INFO. onClick(%s)", ResUtil.getId(v.getId()));
		
		if (v.getId() == R.id.clear) {
			clearWidgets();
		} 
	}

	protected abstract void clearWidgets();

	protected void initWidgets() {

		btnClear = (Button) findViewById(R.id.clear);
		if(btnClear != null)
			btnClear.setOnClickListener(this);
		
		btnOption = (Button) findViewById(R.id.option);
		if(btnOption != null)
			btnOption.setOnClickListener(this);
		
		ASRLog.i(TAG, ASRLog.INFO, "INFO. initWidgets()");
	}

	protected void enableActionWidgets(boolean enabled) {
		// Always enable 'btnClear', 'btnOption' buttons regardless of inventory status.
		if(btnClear != null)
			btnClear.setEnabled(true);
		
		if(btnOption != null)
			btnOption.setEnabled(true);
		
		ASRLog.i(TAG, ASRLog.INFO, "INFO. enableActionWidgets(%s)", enabled);
	}

}
