package jp.co.asterisk.asreader.l251g.support.view.sub.barcode.symbol;

import jp.co.asterisk.asreader.l251g.support.adapter.SpinnerAdapter;
import jp.co.asterisk.asreader.l251g.support.dialog.WaitDialog;
import jp.co.asterisk.asreader.l251g.support.view.base.RfidActivity;

import com.asreader.lib.barcode.spc.ParamValueList;
import com.asreader.lib.barcode.spc.type.ParamName;
import com.asreader.lib.diagnostics.ASRLog;
import jp.co.asterisk.asreader.l251g.R;

import android.app.ActionBar;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

public class UpcEanSymbolActivity extends RfidActivity implements OnClickListener {

	private static final String TAG = UpcEanSymbolActivity.class.getSimpleName();
	
	private TextView txtUpcACheckDigit;
	private TextView txtUpcANumberSystem;
	private TextView txtUpcA2DigitAddenda;
	private TextView txtUpcA5DigitAddenda;
	private TextView txtUpcAAddendaRequired;
	private TextView txtUpcAAddendaSeperator;
	private TextView txtCouponGs1DatabarOutput;
	private TextView txtUpcE0Expand;
	private TextView txtUpcE0AddendaRequired;
	private TextView txtUpcE0AddendaSeperator;
	private TextView txtUpcE0CheckDigit;
	private TextView txtUpcE02DigitAddenda;
	private TextView txtUpcE05DigitAddenda;
	private TextView txtConvertUpcAtoEan13;
	private TextView txtEan13CheckDigit;
	private TextView txtEan132DigitAddenda;
	private TextView txtEan135DigitAddenda;
	private TextView txtEan13AddendaRequired;
	private TextView txtEan13AddendaSeperator;
	private TextView txtIsbnTranslate;
	private TextView txtEan8CheckDigit;
	private TextView txtEan82DigitAddenda;
	private TextView txtEan85DigitAddenda;
	private TextView txtEan8AddendaRequired;
	private TextView txtEan8AddendaSeperator;
	private Button btnSave;
	private Button btnDefault;
	
	private int mUpcACheckDigit;
	private int mUpcANumberSystem;
	private int mUpcA2DigitAddenda;
	private int mUpcA5DigitAddenda;
	private int mUpcAAddendaRequired;
	private int mUpcAAddendaSeperator;
	private int mCouponGs1DatabarOutput;
	private int mUpcE0Expand;
	private int mUpcE0AddendaRequired;
	private int mUpcE0AddendaSeperator;
	private int mUpcE0CheckDigit;
	private int mUpcE02DigitAddenda;
	private int mUpcE05DigitAddenda;
	private int mConvertUpcAtoEan13;
	private int mEan13CheckDigit;
	private int mEan132DigitAddenda;
	private int mEan135DigitAddenda;
	private int mEan13AddendaRequired;
	private int mEan13AddendaSeperator;
	private int mIsbnTranslate;
	private int mEan8CheckDigit;
	private int mEan82DigitAddenda;
	private int mEan85DigitAddenda;
	private int mEan8AddendaRequired;
	private int mEan8AddendaSeperator; 
	
	private String[] mOnOffs = new String[]{"Off", "On"};
	private String[] mAddendaRequireds = new String[]{"Not Required", "Required"};
	
	private Handler mEvent;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_barcode_option_symbol_upc_ean);
		ActionBar actionBar = getActionBar();
		if(actionBar != null) {
			actionBar.setDisplayHomeAsUpEnabled(true);
		}

		ASRLog.i(TAG, ASRLog.INFO, "INFO. onCreate()");

		// Create Reader
		this.createReader();

		// Initialize Widget
		this.initWidgets();

		// Initialize Reader
		this.initReader();

		// Enable action widget
		this.enableActionWidgets(true);
		
		mEvent = new Handler();
	}

	@Override
	protected void onDestroy() {

		ASRLog.i(TAG, ASRLog.INFO, "INFO. onDestroy()");

		// Destroy Reader
		this.destroyReader();

		super.onDestroy();
	}
	
	

	@Override
	protected void onStart() {
		super.onStart();
		WaitDialog.show(this, R.string.barcode_load_param);
		new Thread(mLoadOption).start();
	}

	@Override
	protected void onStop() {
		super.onStop();
	}

	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {

		ASRLog.d(TAG, ASRLog.DEBUG, "DEBUG. onActivityResult(%s, %s)", getRequestCode(requestCode), getResultCode(resultCode));

		super.onActivityResult(requestCode, resultCode, data);
	}

	@Override
	protected void initWidgets() {
		txtUpcACheckDigit = (TextView) findViewById(R.id.upca_check_digit);
		txtUpcACheckDigit.setOnClickListener(this);
		txtUpcANumberSystem = (TextView) findViewById(R.id.upca_number_system);
		txtUpcANumberSystem.setOnClickListener(this);
		txtUpcA2DigitAddenda = (TextView) findViewById(R.id.upca_2digit_addenda);
		txtUpcA2DigitAddenda.setOnClickListener(this);
		txtUpcA5DigitAddenda = (TextView) findViewById(R.id.upca_5digit_addenda);
		txtUpcA5DigitAddenda.setOnClickListener(this);
		txtUpcAAddendaRequired = (TextView) findViewById(R.id.upca_addenda_required);
		txtUpcAAddendaRequired.setOnClickListener(this);
		txtUpcAAddendaSeperator = (TextView) findViewById(R.id.upca_addenda_seperator);
		txtUpcAAddendaSeperator.setOnClickListener(this);
		txtCouponGs1DatabarOutput = (TextView) findViewById(R.id.coupon_gs1_databar_output);
		txtCouponGs1DatabarOutput.setOnClickListener(this);
		txtUpcE0Expand = (TextView) findViewById(R.id.upce0_expand);
		txtUpcE0Expand.setOnClickListener(this);
		txtUpcE0AddendaRequired = (TextView) findViewById(R.id.upce0_addenda_required);
		txtUpcE0AddendaRequired.setOnClickListener(this);
		txtUpcE0AddendaSeperator = (TextView) findViewById(R.id.upce0_addenda_seperator);
		txtUpcE0AddendaSeperator.setOnClickListener(this);
		txtUpcE0CheckDigit = (TextView) findViewById(R.id.upce0_check_digit);
		txtUpcE0CheckDigit.setOnClickListener(this);
		txtUpcE02DigitAddenda = (TextView) findViewById(R.id.upce0_2digit_addenda);
		txtUpcE02DigitAddenda.setOnClickListener(this);
		txtUpcE05DigitAddenda = (TextView) findViewById(R.id.upce0_5digit_addenda);
		txtUpcE05DigitAddenda.setOnClickListener(this);
		txtConvertUpcAtoEan13 = (TextView) findViewById(R.id.convert_upca_to_ean13);
		txtConvertUpcAtoEan13.setOnClickListener(this);
		txtEan13CheckDigit = (TextView) findViewById(R.id.ean13_check_digit);
		txtEan13CheckDigit.setOnClickListener(this);
		txtEan132DigitAddenda = (TextView) findViewById(R.id.ean13_2digit_addenda);
		txtEan132DigitAddenda.setOnClickListener(this);
		txtEan135DigitAddenda = (TextView) findViewById(R.id.ean13_5digit_addenda);
		txtEan135DigitAddenda.setOnClickListener(this);
		txtEan13AddendaRequired = (TextView) findViewById(R.id.ean13_addenda_required);
		txtEan13AddendaRequired.setOnClickListener(this);
		txtEan13AddendaSeperator = (TextView) findViewById(R.id.ean13_addenda_seperator);
		txtEan13AddendaSeperator.setOnClickListener(this);
		txtIsbnTranslate = (TextView) findViewById(R.id.isbn_translate);
		txtIsbnTranslate.setOnClickListener(this);
		txtEan8CheckDigit = (TextView) findViewById(R.id.ean8_check_digit);
		txtEan8CheckDigit.setOnClickListener(this);
		txtEan82DigitAddenda = (TextView) findViewById(R.id.ean8_2digit_addenda);
		txtEan82DigitAddenda.setOnClickListener(this);
		txtEan85DigitAddenda = (TextView) findViewById(R.id.ean8_5digit_addenda);
		txtEan85DigitAddenda.setOnClickListener(this);
		txtEan8AddendaRequired = (TextView) findViewById(R.id.ean8_addenda_required);
		txtEan8AddendaRequired.setOnClickListener(this);
		txtEan8AddendaSeperator = (TextView) findViewById(R.id.ean8_addenda_seperator);
		txtEan8AddendaSeperator.setOnClickListener(this);
		
		btnSave = (Button) findViewById(R.id.save);
		btnSave.setOnClickListener(this);
		btnDefault = (Button) findViewById(R.id.option_default);
		btnDefault.setOnClickListener(this);
	}

	@Override
	protected void enableActionWidgets(boolean enabled) {
		btnSave.setEnabled(enabled);
		btnDefault.setEnabled(enabled);
	}

	@Override
	protected void initReader() {

	}

	private void displayValues() {
		
		txtUpcACheckDigit.setText(mOnOffs[mUpcACheckDigit]);
		txtUpcANumberSystem.setText(mOnOffs[mUpcANumberSystem]);
		txtUpcA2DigitAddenda.setText(mOnOffs[mUpcA2DigitAddenda]);
		txtUpcA5DigitAddenda.setText(mOnOffs[mUpcA5DigitAddenda]);
		txtUpcAAddendaRequired.setText(mAddendaRequireds[mUpcAAddendaRequired]);
		txtUpcAAddendaSeperator.setText(mOnOffs[mUpcAAddendaSeperator]);
		txtCouponGs1DatabarOutput.setText(mOnOffs[mCouponGs1DatabarOutput]);
		txtUpcE0Expand.setText(mOnOffs[mUpcE0Expand]);
		txtUpcE0AddendaRequired.setText(mAddendaRequireds[mUpcE0AddendaRequired]);
		txtUpcE0AddendaSeperator.setText(mOnOffs[mUpcE0AddendaSeperator]);
		txtUpcE0CheckDigit.setText(mOnOffs[mUpcE0CheckDigit]);
		txtUpcE02DigitAddenda.setText(mOnOffs[mUpcE02DigitAddenda]);
		txtUpcE05DigitAddenda.setText(mOnOffs[mUpcE05DigitAddenda]);
		txtConvertUpcAtoEan13.setText(mOnOffs[mConvertUpcAtoEan13]);
		txtEan13CheckDigit.setText(mOnOffs[mEan13CheckDigit]);
		txtEan132DigitAddenda.setText(mOnOffs[mEan132DigitAddenda]);
		txtEan135DigitAddenda.setText(mOnOffs[mEan135DigitAddenda]);
		txtEan13AddendaRequired.setText(mAddendaRequireds[mEan13AddendaRequired]);
		txtEan13AddendaSeperator.setText(mOnOffs[mEan13AddendaSeperator]);
		txtIsbnTranslate.setText(mOnOffs[mIsbnTranslate]);
		txtEan8CheckDigit.setText(mOnOffs[mEan8CheckDigit]);
		txtEan82DigitAddenda.setText(mOnOffs[mEan82DigitAddenda]);
		txtEan85DigitAddenda.setText(mOnOffs[mEan85DigitAddenda]);
		txtEan8AddendaRequired.setText(mAddendaRequireds[mEan8AddendaRequired]);
		txtEan8AddendaSeperator.setText(mOnOffs[mEan8AddendaSeperator]);
	}
	
	private Runnable mLoadOption = new Runnable() {

		@Override
		public void run() {
			
			ParamValueList values = getReader().getBarcodeParam(new ParamName[] { 
					ParamName.UPCACheckDigit, 
					ParamName.UPCANumberSystem,
					ParamName.UPCA2DigitAdd, 
					ParamName.UPCA5DigitAdd, 
					ParamName.UPCAAddReq,
					ParamName.UPCAAddSep,
					ParamName.UPCACouponCode,
					ParamName.CouponGS1DataBarOutput,
					ParamName.UPCE0Expand,
					ParamName.UPCE0AddReq,
					ParamName.UPCE0AddSep,
					ParamName.UPCE0CheckDigit,
					ParamName.UPCE02DigitAdd,
					ParamName.UPCE05DigitAdd,
					ParamName.ConvertUPCAtoEAN13,
					ParamName.EAN13CheckDigit,
					ParamName.EAN132DigitAdd,
					ParamName.EAN135DigitAdd,
					ParamName.EAN13AddReq,
					ParamName.EAN13AddSep,
					ParamName.IsbnTranslate,
					ParamName.EAN8CheckDigit,
					ParamName.EAN82DigitAdd,
					ParamName.EAN85DigitAdd,
					ParamName.EAN8AddReq,
					ParamName.EAN8AddSep,
			});
			
			mUpcACheckDigit = values.getValue(ParamName.UPCACheckDigit);
			mUpcANumberSystem = values.getValue(ParamName.UPCANumberSystem);
			mUpcA2DigitAddenda = values.getValue(ParamName.UPCA2DigitAdd);
			mUpcA5DigitAddenda = values.getValue(ParamName.UPCA5DigitAdd);
			mUpcAAddendaRequired = values.getValue(ParamName.UPCAAddReq);
			mUpcAAddendaSeperator = values.getValue(ParamName.UPCAAddSep);
			mCouponGs1DatabarOutput = values.getValue(ParamName.CouponGS1DataBarOutput);
			mUpcE0Expand = values.getValue(ParamName.UPCE0Expand);
			mUpcE0AddendaRequired = values.getValue(ParamName.UPCE0AddReq);
			mUpcE0AddendaSeperator = values.getValue(ParamName.UPCE0AddSep);
			mUpcE0CheckDigit = values.getValue(ParamName.UPCE0CheckDigit);
			mUpcE02DigitAddenda = values.getValue(ParamName.UPCE02DigitAdd);
			mUpcE05DigitAddenda = values.getValue(ParamName.UPCE05DigitAdd);
			mConvertUpcAtoEan13 = values.getValue(ParamName.ConvertUPCAtoEAN13);
			mEan13CheckDigit = values.getValue(ParamName.EAN13CheckDigit);
			mEan132DigitAddenda = values.getValue(ParamName.EAN132DigitAdd);
			mEan135DigitAddenda = values.getValue(ParamName.EAN135DigitAdd);
			mEan13AddendaRequired = values.getValue(ParamName.EAN13AddReq);
			mEan13AddendaSeperator = values.getValue(ParamName.EAN13AddSep);
			mIsbnTranslate = values.getValue(ParamName.IsbnTranslate);
			mEan8CheckDigit = values.getValue(ParamName.EAN8CheckDigit);
			mEan82DigitAddenda = values.getValue(ParamName.EAN82DigitAdd);
			mEan85DigitAddenda = values.getValue(ParamName.EAN85DigitAdd);
			mEan8AddendaRequired = values.getValue(ParamName.EAN8AddReq);
			mEan8AddendaSeperator = values.getValue(ParamName.EAN8AddSep);
			
			mEvent.post(new Runnable() {

				@Override
				public void run() {
					displayValues();
					enableActionWidgets(true);
					WaitDialog.hide();
				}
				
			});
		}
		
	};
	
	private Runnable mDefaultOption = new Runnable() {

		@Override
		public void run() {
			ParamValueList values = new ParamValueList();
			
			values.add(ParamName.UPCADefault);
			values.add(ParamName.UPCE0Default);
			values.add(ParamName.EAN13Default);
			values.add(ParamName.EAN8Default);
			
			getReader().setBarcodeParam(values);
			
			mEvent.post(new Runnable() {

				@Override
				public void run() {
					WaitDialog.hide();
					finish();
				}

			});
		}
		
	};
	
	private Runnable mSaveOption = new Runnable() {

		@Override
		public void run() {
			
			ParamValueList values = new ParamValueList();
			
			values.add(ParamName.UPCACheckDigit, mUpcACheckDigit);
			values.add(ParamName.UPCANumberSystem, mUpcANumberSystem);
			values.add(ParamName.UPCA2DigitAdd, mUpcA2DigitAddenda);
			values.add(ParamName.UPCA5DigitAdd, mUpcA5DigitAddenda);
			values.add(ParamName.UPCAAddReq, mUpcAAddendaRequired);
			values.add(ParamName.UPCAAddSep, mUpcAAddendaSeperator);
			values.add(ParamName.CouponGS1DataBarOutput, mCouponGs1DatabarOutput);
			values.add(ParamName.UPCE0Expand, mUpcE0Expand);
			values.add(ParamName.UPCE0AddReq, mUpcE0AddendaRequired);
			values.add(ParamName.UPCE0AddSep, mUpcE0AddendaSeperator);
			values.add(ParamName.UPCE0CheckDigit, mUpcE0CheckDigit);
			values.add(ParamName.UPCE02DigitAdd, mUpcE02DigitAddenda);
			values.add(ParamName.UPCE05DigitAdd, mUpcE05DigitAddenda);
			values.add(ParamName.ConvertUPCAtoEAN13, mConvertUpcAtoEan13);
			values.add(ParamName.EAN13CheckDigit, mEan13CheckDigit);
			values.add(ParamName.EAN132DigitAdd, mEan132DigitAddenda);
			values.add(ParamName.EAN135DigitAdd, mEan135DigitAddenda);
			values.add(ParamName.EAN13AddReq, mEan13AddendaRequired);
			values.add(ParamName.EAN13AddSep, mEan13AddendaSeperator);
			values.add(ParamName.IsbnTranslate, mIsbnTranslate);
			values.add(ParamName.EAN8CheckDigit, mEan8CheckDigit);
			values.add(ParamName.EAN82DigitAdd, mEan82DigitAddenda);
			values.add(ParamName.EAN85DigitAdd, mEan85DigitAddenda);
			values.add(ParamName.EAN8AddReq, mEan8AddendaRequired);
			values.add(ParamName.EAN8AddSep, mEan8AddendaSeperator);
			
			getReader().setBarcodeParam(values);
			
			mEvent.post(new Runnable() {

				@Override
				public void run() {
					WaitDialog.hide();
					finish();
				}

			});
		}
		
	};
	
	private int getStringId(ParamName name) {
		switch(name) {
		case UPCACheckDigit:
			return R.string.upca_check_digit;
		case UPCANumberSystem:
			return R.string.upca_number_system;
		case UPCA2DigitAdd:
			return R.string.upca_2digit_addenda;
		case UPCA5DigitAdd:
			return R.string.upca_5digit_addenda;
		case UPCAAddReq:
			return R.string.upca_addenda_required;
		case UPCAAddSep:
			return R.string.upca_addenda_seperator;
		case UPCACouponCode:
			return R.string.extended_coupon_code;
		case CouponGS1DataBarOutput:
			return R.string.coupon_gs1_databar_output;
		case UPCE0Expand:
			return R.string.upce0_expand;
		case UPCE0AddReq:
			return R.string.upce0_addenda_required;
		case UPCE0AddSep:
			return R.string.upce0_addenda_seperator;
		case UPCE0CheckDigit:
			return R.string.upce0_check_digit;
		case UPCE02DigitAdd:
			return R.string.upce0_2digit_addenda;
		case UPCE05DigitAdd:
			return R.string.upce0_5digit_addenda;
		case ConvertUPCAtoEAN13:
			return R.string.convert_upca_to_ean13;
		case EAN13CheckDigit:
			return R.string.ean13_check_digit;
		case EAN132DigitAdd:
			return R.string.ean13_2digit_addenda;
		case EAN135DigitAdd:
			return R.string.ean13_5digit_addenda;
		case EAN13AddReq:
			return R.string.ean13_addenda_required;
		case EAN13AddSep:
			return R.string.ean13_addenda_seperator;
		case IsbnTranslate:
			return R.string.isbn_translate;
		case EAN8CheckDigit:
			return R.string.ean8_check_digit;
		case EAN82DigitAdd:
			return R.string.ean8_2digit_addenda;
		case EAN85DigitAdd:
			return R.string.ean8_5digit_addenda;
		case EAN8AddReq:
			return R.string.ean8_addenda_required;
		case EAN8AddSep:
			return R.string.ean8_addenda_seperator;
		default:
			return -1;
		}
	}
	
	private ParamName getName(int id) {
		switch(id) {
		
		case R.id.upca_check_digit:
			return ParamName.UPCACheckDigit;
		case R.id.upca_number_system:
			return ParamName.UPCANumberSystem;
		case R.id.upca_2digit_addenda:
			return ParamName.UPCA2DigitAdd;
		case R.id.upca_5digit_addenda:
			return ParamName.UPCA5DigitAdd;
		case R.id.upca_addenda_required:
			return ParamName.UPCAAddReq;
		case R.id.upca_addenda_seperator:
			return ParamName.UPCAAddSep;
		case R.id.coupon_gs1_databar_output:
			return ParamName.CouponGS1DataBarOutput;
		case R.id.upce0_expand:
			return ParamName.UPCE0Expand;
		case R.id.upce0_addenda_required:
			return ParamName.UPCE0AddReq;
		case R.id.upce0_addenda_seperator:
			return ParamName.UPCE0AddSep;
		case R.id.upce0_check_digit:
			return ParamName.UPCE0CheckDigit;
		case R.id.upce0_2digit_addenda:
			return ParamName.UPCE02DigitAdd;
		case R.id.upce0_5digit_addenda:
			return ParamName.UPCE05DigitAdd;
		case R.id.convert_upca_to_ean13:
			return ParamName.ConvertUPCAtoEAN13;
		case R.id.ean13_check_digit:
			return ParamName.EAN13CheckDigit;
		case R.id.ean13_2digit_addenda:
			return ParamName.EAN132DigitAdd;
		case R.id.ean13_5digit_addenda:
			return ParamName.EAN135DigitAdd;
		case R.id.ean13_addenda_required:
			return ParamName.EAN13AddReq;
		case R.id.ean13_addenda_seperator:
			return ParamName.EAN13AddSep;
		case R.id.isbn_translate:
			return ParamName.IsbnTranslate;
		case R.id.ean8_check_digit:
			return ParamName.EAN8CheckDigit;
		case R.id.ean8_2digit_addenda:
			return ParamName.EAN82DigitAdd;
		case R.id.ean8_5digit_addenda:
			return ParamName.EAN85DigitAdd;
		case R.id.ean8_addenda_required:
			return ParamName.EAN8AddReq;
		case R.id.ean8_addenda_seperator:
			return ParamName.EAN8AddSep;
		default:
			return ParamName.Unknown;
		}
	}
	
	private void setValue(ParamName name, int value) {
		switch(name) {
		case UPCACheckDigit:
			this.mUpcACheckDigit = value;
			break;
		case UPCANumberSystem:
			this.mUpcANumberSystem = value;
			break;
		case UPCA2DigitAdd:
			this.mUpcA2DigitAddenda = value;
			break;
		case UPCA5DigitAdd:
			this.mUpcA5DigitAddenda = value;
			break;
		case UPCAAddReq:
			this.mUpcAAddendaRequired = value;
			break;
		case UPCAAddSep:
			this.mUpcAAddendaSeperator = value;
			break;
		case CouponGS1DataBarOutput:
			this.mCouponGs1DatabarOutput = value;
			break;
		case UPCE0Expand:
			this.mUpcE0Expand = value;
			break;
		case UPCE0AddReq:
			this.mUpcE0AddendaRequired = value;
			break;
		case UPCE0AddSep:
			this.mUpcE0AddendaSeperator = value;
			break;
		case UPCE0CheckDigit:
			this.mUpcE0CheckDigit = value;
			break;
		case UPCE02DigitAdd:
			this.mUpcE02DigitAddenda = value;
			break;
		case UPCE05DigitAdd:
			this.mUpcE05DigitAddenda = value;
			break;
		case ConvertUPCAtoEAN13:
			this.mConvertUpcAtoEan13 = value;
			break;
		case EAN13CheckDigit:
			this.mEan13CheckDigit = value;
			break;
		case EAN132DigitAdd:
			this.mEan132DigitAddenda = value;
			break;
		case EAN135DigitAdd:
			this.mEan135DigitAddenda = value;
			break;
		case EAN13AddReq:
			this.mEan13AddendaRequired = value;
			break;
		case EAN13AddSep:
			this.mEan13AddendaSeperator = value;
			break;
		case IsbnTranslate:
			this.mIsbnTranslate = value;
			break;
		case EAN8CheckDigit:
			this.mEan8CheckDigit = value;
			break;
		case EAN82DigitAdd:
			this.mEan82DigitAddenda = value;
			break;
		case EAN85DigitAdd:
			this.mEan85DigitAddenda = value;
			break;
		case EAN8AddReq:
			this.mEan8AddendaRequired = value;
			break;
		case EAN8AddSep:
			this.mEan8AddendaSeperator = value;
			break;
		default:
			break;
		}
	}
	
	private int getValue(ParamName name) {
		switch(name) {
		case UPCACheckDigit:
			return this.mUpcACheckDigit;
		case UPCANumberSystem:
			return this.mUpcANumberSystem;
		case UPCA2DigitAdd:
			return this.mUpcA2DigitAddenda;
		case UPCA5DigitAdd:
			return this.mUpcA5DigitAddenda;
		case UPCAAddReq:
			return this.mUpcAAddendaRequired;
		case UPCAAddSep:
			return this.mUpcAAddendaSeperator;
		case CouponGS1DataBarOutput:
			return this.mCouponGs1DatabarOutput;
		case UPCE0Expand:
			return this.mUpcE0Expand;
		case UPCE0AddReq:
			return this.mUpcE0AddendaRequired;
		case UPCE0AddSep:
			return this.mUpcE0AddendaSeperator;
		case UPCE0CheckDigit:
			return this.mUpcE0CheckDigit;
		case UPCE02DigitAdd:
			return this.mUpcE02DigitAddenda;
		case UPCE05DigitAdd:
			return this.mUpcE05DigitAddenda;
		case ConvertUPCAtoEAN13:
			return this.mConvertUpcAtoEan13;
		case EAN13CheckDigit:
			return this.mEan13CheckDigit;
		case EAN132DigitAdd:
			return this.mEan132DigitAddenda;
		case EAN135DigitAdd:
			return this.mEan135DigitAddenda;
		case EAN13AddReq:
			return this.mEan13AddendaRequired;
		case EAN13AddSep:
			return this.mEan13AddendaSeperator;
		case IsbnTranslate:
			return this.mIsbnTranslate;
		case EAN8CheckDigit:
			return this.mEan8CheckDigit;
		case EAN82DigitAdd:
			return this.mEan82DigitAddenda;
		case EAN85DigitAdd:
			return this.mEan85DigitAddenda;
		case EAN8AddReq:
			return this.mEan8AddendaRequired;
		case EAN8AddSep:
			return this.mEan8AddendaSeperator;
		default:
			return -1;
		}
	}
	
	private void showAddendaRequriedDialog(final ParamName name) {
		LinearLayout root = (LinearLayout) LinearLayout.inflate(this, R.layout.dialog_list_view, null);
		final ListView value = (ListView) root.findViewById(R.id.list);
		final SpinnerAdapter adapter = new SpinnerAdapter(this, android.R.layout.simple_list_item_single_choice);
		for(int i=0; i<mAddendaRequireds.length; i++) {
			adapter.addItem(i, mAddendaRequireds[i]);
		}
		value.setAdapter(adapter);
		value.setChoiceMode(ListView.CHOICE_MODE_SINGLE);
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setTitle(getStringId(name));
		builder.setView(root);
		builder.setPositiveButton(R.string.action_ok, new DialogInterface.OnClickListener() {

			@Override
			public void onClick(DialogInterface dialog, int which) {
				try {
					int position = value.getCheckedItemPosition();
					setValue(name, adapter.getValue(position));
				} catch (Exception e) {
				}
				displayValues();
				ASRLog.i(TAG, ASRLog.INFO, "INFO. showStartStopCharDialog().$PositiveButton.onClick()");
			}
		});
		builder.setNegativeButton(R.string.action_cancel, new DialogInterface.OnClickListener() {

			@Override
			public void onClick(DialogInterface dialog, int which) {
				ASRLog.i(TAG, ASRLog.INFO, "INFO. showStartStopCharDialog().$NegativeButton.onClick()");
			}
		});
		builder.setCancelable(true);
		builder.setOnCancelListener(new DialogInterface.OnCancelListener() {

			@Override
			public void onCancel(DialogInterface dialog) {
				ASRLog.i(TAG, ASRLog.INFO, "INFO. showStartStopCharDialog().onCancel()");
			}
		});
		AlertDialog dialog = builder.create();
		dialog.setOnShowListener(new DialogInterface.OnShowListener() {

			@Override
			public void onShow(DialogInterface dialog) {
				int position = adapter.getPosition(getValue(name));
				value.setItemChecked(position, true);
				value.setSelectionFromTop(position, 0);
				ASRLog.i(TAG, ASRLog.INFO, "INFO. showStartStopCharDialog().onShow()");
			}
		});
		dialog.show();
	}
	
	private void showOnOffDialog(final ParamName name) {
		LinearLayout root = (LinearLayout) LinearLayout.inflate(this, R.layout.dialog_list_view, null);
		final ListView value = (ListView) root.findViewById(R.id.list);
		final SpinnerAdapter adapter = new SpinnerAdapter(this, android.R.layout.simple_list_item_single_choice);
		for(int i=0; i<mOnOffs.length; i++) {
			adapter.addItem(i, mOnOffs[i]);
		}
		value.setAdapter(adapter);
		value.setChoiceMode(ListView.CHOICE_MODE_SINGLE);
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setTitle(getStringId(name));
		builder.setView(root);
		builder.setPositiveButton(R.string.action_ok, new DialogInterface.OnClickListener() {

			@Override
			public void onClick(DialogInterface dialog, int which) {
				try {
					int position = value.getCheckedItemPosition();
					setValue(name, adapter.getValue(position));
				} catch (Exception e) {
				}
				displayValues();
				ASRLog.i(TAG, ASRLog.INFO, "INFO. showStartStopCharDialog().$PositiveButton.onClick()");
			}
		});
		builder.setNegativeButton(R.string.action_cancel, new DialogInterface.OnClickListener() {

			@Override
			public void onClick(DialogInterface dialog, int which) {
				ASRLog.i(TAG, ASRLog.INFO, "INFO. showStartStopCharDialog().$NegativeButton.onClick()");
			}
		});
		builder.setCancelable(true);
		builder.setOnCancelListener(new DialogInterface.OnCancelListener() {

			@Override
			public void onCancel(DialogInterface dialog) {
				ASRLog.i(TAG, ASRLog.INFO, "INFO. showStartStopCharDialog().onCancel()");
			}
		});
		AlertDialog dialog = builder.create();
		dialog.setOnShowListener(new DialogInterface.OnShowListener() {

			@Override
			public void onShow(DialogInterface dialog) {
				int position = adapter.getPosition(getValue(name));
				value.setItemChecked(position, true);
				value.setSelectionFromTop(position, 0);
				ASRLog.i(TAG, ASRLog.INFO, "INFO. showStartStopCharDialog().onShow()");
			}
		});
		dialog.show();
	}

	@Override
	public void onClick(View v) {
		switch(v.getId()) {
		case R.id.upca_addenda_required:
		case R.id.upce0_addenda_required:
		case R.id.ean13_addenda_required:
		case R.id.ean8_addenda_required:
			showAddendaRequriedDialog(getName(v.getId()));
			break;
		case R.id.save:
			enableActionWidgets(false);
			WaitDialog.show(this, R.string.save_option);
			new Thread(mSaveOption).start();
			break;
		case R.id.option_default:
			enableActionWidgets(false);
			WaitDialog.show(this, R.string.load_default_option);
			new Thread(mDefaultOption).start();
			break;
		default:
			showOnOffDialog(getName(v.getId()));
			break;
		}
	}
}
